<?php
namespace Teknisa\FIS\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\FIS\Factories\Ger01200EstadoFactory;

class Ger01200EstadoService{
    protected $dataSourceManager;
    protected $ger01200estadofactory;

    public function __construct($dataSourceManager, $ger01200estadofactory){
        $this->dataSourceManager = $dataSourceManager;
        $this->ger01200estadofactory = $ger01200estadofactory;
    }

    public function saveEstado($row){
        if($row['__is_new']){
            $this->verficaSiglaEstado($row);
        }
        $this->verficaNomeEstado($row);
        $array[] = $row;
        $dataSet = new DataSet('estado', $array);
        $this->dataSourceManager->persist($dataSet);
    }

    //não permite salvar estado com mesmo nome para um mesmo pais
    public function verficaNomeEstado($row){
        $resultadoBanco = $this->ger01200estadofactory->verficaNomeEstado($row);
        if(!empty ($resultadoBanco) ){
            // no caso de edição para verificar se o ESTADO ja existe na base e está sendo editado
            if($resultadoBanco[0]['SGESTADO']  !== $row['SGESTADO']){
                throw new \Exception("Nome já cadastrado.", 1);

            }
        }
    }
    
    public function verficaSiglaEstado($row){
        $resultadoBanco = $this->ger01200estadofactory->verficaSiglaEstado($row);
        if(!empty($resultadoBanco)){
            throw new \Exception("Sigla já cadastrada.", 1);
        }
    }

}