<?php

namespace Teknisa\FIS\Utilities;

class MessagesFiscal {

    const SUCCESS_MESSAGE_CODE = 10;
    const ALERT_MESSAGE_CODE   = 20;
    const ERROR_MESSAGE_CODE   = 30;


    const PARMAFISCAL_VAZIO   = "Parâmetros do Fiscal não Cadastrado.";
    
    /******************************************
    *                                         *
    *                 REINF                   *
    *                                         *  
    *******************************************/
    
    const DADOS_LOTE_VAZIO   = "Não foram encontrados dados para envio do
        lote.";
    const CERT_NAO_ECONTRADO = "Certificado do transmissor não encontrado.
        Favor carregar o certificado na tela 'Parametros do Reinf'.";
    const ENVIO_LOTE_SUCESSO = "Lote enviado com sucesso.";
    const NAO_EXISTE_MAPA    = "Não existe nenhum mapa cadastrado para o
        período informado.";
    const MAPA_VAZIO         = "O mapa não possui informações para o período
        informado.";
    const SUCESSO_2010       = "Foram inseridos eventos para todos os tomadores
        referente ao período informado.";
    const SUCESSO_2020       = "Foram inseridos eventos para todos os
        prestadores referente ao período informado.";
    const EXISTE_EVT_2010    = "Já foi inserido o evento R-2010 para este 
        período. Só serão inseridos novos registros caso exista um novo 
        tomador.";
    const EXISTE_EVT_2020    = "Já foi inserido o evento R-2020 para este 
        período. Só serão inseridos novos registros caso e
        prestador.";
    const NOTAS_ITENS_SEM_SERVICO = "O(s) lançamento(s) <>NOTAS<> não 
        apresenta(ão) nenhum item com parametrização de serviço e por isso não 
        foi(ram) enviado(s).";
    const EVENTO_EXCLUIDO = "Esse evento foi excluído pelo envio <>NRENVIO<>, 
        pelo operador <>CDOPERADOR<>";
    const R1000_INEXISTENTE = "Não existem R-1000 concluídos ou em
        processamento para serem excluídos.";
    const R1000_SEM_VALIDADE = "Existe um R-1000 vigente sem data de validade.
        Não é possível inserir outro R-1000.";
    const R1000_EXISTENTE_PARA_VALIDADE = "Não é possível inserir outro R-1000
        pois existe um R-1000 vigente dentro da data de validade.";
    const NAO_EXISTE_R2099_PARA_PERIODO = "Não existe nenhum evento R-2099 em 
        processamento ou concluído para o periodo informado. Por isso, não é 
        possível inserir um envento R-2098 para o perídodo selecionado.";
    const CONSULTA_SUCESSO = "Consulta realizada com sucesso.";
    const EVENTO_REABERTO = "Esse evento foi reaberto pelo envio <>NRENVIO<>, 
        pelo operador <>CDOPERADOR<>";
    const EXCLUSAO_NEGADA = "So podem ser excluídos eventos que não tenham
        recibo, ou que não estejam concluidos ou em processamento.";
    
    
    public static function notasItensSemServico($notas) {
        $nrlanctonfs = join(", ", array_map(function($nota) {
            return $nota['NRLANCTONF'];
        }, $notas));
        // return self::NOTAS_ITENS_SEM_SERVICO;
        return str_replace('<>NOTAS<>', $nrlanctonfs,
            self::NOTAS_ITENS_SEM_SERVICO);
    }
    
    public static function messagemEventoExcluido($nrenvio, $cdoperador) {
        $messagem = str_replace('<>NRENVIO<>', $nrenvio,
            MessagesFiscal::EVENTO_EXCLUIDO);
        $messagem = str_replace('<>CDOPERADOR<>', $cdoperador, $messagem);
        return $messagem;
    }
    
    public static function messagemPeriodoReaberto($nrenvio, $cdoperador) {
        $messagem = str_replace('<>NRENVIO<>', $nrenvio,
            MessagesFiscal::EVENTO_REABERTO);
        $messagem = str_replace('<>CDOPERADOR<>', $cdoperador, $messagem);
        return $messagem;
    }

    /******************************************
    *                                         *
    *         DOCUMENTO DE ARRECAÇÃO          *
    *                                         *  
    *******************************************/
    
    const PREPARACAO_NAO_REALIZADA= "Preparação de Pagamento não foi
        realizada.";
    const PREPARACAO_REALIZADA    = "Preparação de Pagamento já foi realizada.";
    const MAPA_NAO_BLOQUEADO      = "Operação Bloqueada! Mapa de apuração não
        está bloqueado.";
    const PARAMETROSIMPOSTO_VAZIO = "Não existe parâmetros cadastrado para o
        imposto informado na tela 'Parâmetros para Emissão de Guia'";
    const BENEFICIARIO_VAZIO      = "Não existe beneficiário cadastrado para o
        imposto informado.";
    const NAO_GERACONTA           = "Não existe parametrização para gerar conta
        à pagar na emissão de guias.";
    const TIPOOPERCAO_VAZIO       = "Tipo de Operação não parametrizado na tela
        'Parâmetros para Emissão de Guia'";
    const ERROCANCELAMENTO1       =  "NOTA POSSUI CONTA BAIXADA";
    const ERROCANCELAMENTO2       =  "NOTA POSSUI CONTA PARCELADA";
    const ERROCANCELAMENTO4       =  "NOTA POSSUI AJUSTES EM BOLETO DAS CONTAS";
    const ERROCANCELAMENTO5       =  "NOTA POSSUI CONTA COM BOLETO REAL (PARA 
        CONTAS A PAGAR)";
    const ERROCANCELAMENTO6       =  "NOTA POSSUI CONTA ENVIADA AO BANCO VIA
        CNAB";
    const ERROCANCELAMENTO7       =  "NOTA POSSUI CONTA DE UM BOLETO ASSOCIADO";
    const ERROCANCELAMENTO8       =  "NOTA DE DEVOLUÇÃO POSSUI VALOR UTILIZADO";
    const GUIA_VENCIDA            =  "A guia encontra-se vencida. É necessário
        emita-la pelo site da Receita Federal.";
    const GUIA_VENCIDA_CONF       = "A guia encontra-se vencida. Deseja
        emiti-la pelo site da Receita Federal? Caso contrário a DARF será emitida
        pelo sistema sem código de barras.";
    
    /*********************************************************
    *                                                        *
    *         Paramtrização de Exportação Municipal          *
    *                                                        *  
    *********************************************************/
    const PRODUTOS_JA_PARAMETRIZADOS = "Alguns produtos selecionados já possuem 
    cadastro para algumas das inscrições passadas.";
    const NAO_INSERIU_ALGUM_PRODUTO = "Alguns produtos não puderam ser inseridos
    automaticamente.";
    const NAO_UPDATAR_ALGUM_PRODUTO = "Alguns produtos não puderam ser alterados
    automaticamente.";
}
 